# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2004-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id: account.py 1005 2005-07-25 08:41:42Z nicoe $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields, osv
import ir

class product_product(osv.osv):
	_name = 'product.template'
	_inherit = 'product.template'
	_columns = {
		'property_stock_procurement': fields.property(
		  'stock.location',
		  type='many2one', 
		  relation='stock.location', 
		  string="Procurement Location", 
		  method=True,
		  view_load=True,
		  group_name="Inventory Properties",
		  help="For the current product (template), this stock location will be used, instead of the default one, as the source location for stock moves generated by procurements"),
		'property_stock_production': fields.property(
		  'stock.location',
		  type='many2one', 
		  relation='stock.location', 
		  string="Production Location", 
		  method=True,
		  view_load=True,
		  group_name="Inventory Properties",
		  help="For the current product (template), this stock location will be used, instead of the default one, as the source location for stock moves generated by production orders"),
		'property_stock_inventory': fields.property(
		  'stock.location',
		  type='many2one', 
		  relation='stock.location', 
		  string="Inventory Location", 
		  method=True,
		  view_load=True,
		  group_name="Inventory Properties",
		  help="For the current product (template), this stock location will be used, instead of the default one, as the source location for stock moves generated when you do an inventory"),
	}
product_product()


